/**
 * Build a string from multiple substrings.
 */
export declare class StringBuilder {
    /**
     * List of all substrings.
     */
    private readonly stringArray;
    /**
     * Append a new substring to the string builder.
     * @param { string } string Substring to append to the string builder.
     */
    append(string: string): void;
    /**
     * Append a new sting with a new line feed to the string builder.
     * @param { string } string Substring to append with a new line feed to the string builder.
     */
    appendLine(string: string): void;
    /**
     * Joins all substring to the result string.
     * @return { string } Result string of the string builder,
     */
    toString(): string;
}
