"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BytesToBitIterator = void 0;
const utils_1 = require("./utils");
class BytesToBitIterator {
    bytesIterator;
    currentBitsIterator;
    constructor(bytes) {
        this.bytesIterator = bytes[Symbol.iterator]();
        const bytesIteratorResult = this.bytesIterator.next();
        if (!(bytesIteratorResult.done ?? false))
            this.currentBitsIterator = (0, utils_1.bits)(bytesIteratorResult.value)[Symbol.iterator]();
    }
    next() {
        if (this.currentBitsIterator === undefined)
            return { done: true, value: undefined };
        const currentBitsIteratorResult = this.currentBitsIterator.next();
        if (!(currentBitsIteratorResult.done ?? false))
            return { value: currentBitsIteratorResult.value };
        const bytesIteratorResult = this.bytesIterator.next();
        if (!(bytesIteratorResult.done ?? false))
            this.currentBitsIterator = (0, utils_1.bits)(bytesIteratorResult.value)[Symbol.iterator]();
        else
            this.currentBitsIterator = undefined;
        return this.next();
    }
}
exports.BytesToBitIterator = BytesToBitIterator;
